%define 	pname awstats
%define 	pversion 6.95
%define 	bversion 118
%define 	rpmrelease iworx

%define 	debug_package %{nil}

# INSTRUCTIONS!!! <--------------------- READ THEM!!!
#
# You can rebuild  this  package safely using Command 
# Line Overrides. For example, if you want to rebuild
# this package for RedHat just type:
# $ rpm --rebuild --with redhat package.src.rpm
# $ rpm -ba --with redhat package.spec
#
# mdk = GNU/Linux Mandrake
# rht = Linux Red-Hat
# sus = Suse Linux
# fdr = Fedora Linux
# cos = CentOS
# whb = White Box Linux
# rhe = Red Hat Enterprise
# unk = Unknown
#

%define		build_unk      1

# Command Line Overrides
%{?_with_unk: 		%{expand: %%define build_unk      1}}

# Distro Statements

##
# THIS MUST BE LAST
##

%if %{build_unk}
%define		release %{bversion}.%{rpmrelease}
%define 	ostype Unknown Distribution
%define		ccflags %{optflags}
%define		ldflags %{optflags}
%endif

############### RPM ################################

Summary:	Advanced Web Statistics
Name:		%{pname}
Version:	%{pversion}
Release:	%{release}
License:	GPL

Group:		Applications/Internet
Source0: 	%{name}-%{version}.tgz
URL:		http://awstats.sourceforge.net

BuildArch:	noarch
BuildRequires:  perl
Requires:       perl
Epoch:		1

Distribution:	InterWorx-HAL
Vendor:		INTERWORX L.L.C.
Packager:	Tim College <tcollege@interworx.com>

BuildRoot:	%{_tmppath}/%{name}-%{version}-root

Source1:	awstats.conf
Patch0:         awstats-perl-regex-fix.patch

%description
Advanced Web Statistics is a powerful and featureful tool that generates
advanced web server graphic statistics. This server log analyzer works
from command line or as a CGI and shows you all information your log contains,
in graphical web pages. It can analyze a lot of web/wap/proxy servers like
Apache, IIS, Weblogic, Webstar, Squid, ... but also mail or ftp servers.

This program can measure visits, unique vistors, authenticated users, pages,
domains/countries, OS busiest times, robot visits, type of files, search
engines/keywords used, visits duration, HTTP errors and more...
Statistics can be updated from a browser or your scheduler.
The program also supports virtual servers, plugins and a lot of features.

%prep

[ -n %{buildroot} ] && rm -rf %{buildroot}

[ -d $RPM_BUILD_DIR/%{name}-%{pversion} ] && rm -rf $RPM_BUILD_DIR/%{name}-%{pversion}

%setup -q
%patch0 -p1

# Try detecting newest gcc (some distributions have got more then one compiler)
[ -f %{_tmppath}/%{name}-%{pversion}-gcc ] && rm -f %{_tmppath}/%{name}-%{pversion}-gcc

if   [ -x /usr/bin/gcc-3.2.3 ]; then
	echo "/usr/bin/gcc-3.2.3" > %{_tmppath}/%{name}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.2 ]; then
	echo "/usr/bin/gcc-3.2.2" > %{_tmppath}/%{name}-%{pversion}-gcc
elif   [ -x /usr/bin/gcc-3.2.1 ]; then
	echo "/usr/bin/gcc-3.2.1" > %{_tmppath}/%{name}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.2 ]; then
        echo "/usr/bin/gcc-3.2" > %{_tmppath}/%{name}-%{pversion}-gcc
elif [ -x /usr/bin/gcc-3.1.1 ]; then
        echo "/usr/bin/gcc-3.1.1" > %{_tmppath}/%{name}-%{pversion}-gcc
else
	echo "gcc" > %{_tmppath}/%{name}-%{pversion}-gcc
fi

# Display compilation flags and OS with nice colors
[ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] && rm -f %{_tmppath}/%{name}-%{pversion}-show_flags
cat <<EOF >>%{_tmppath}/%{name}-%{pversion}-show_flags
#!/bin/sh

RPM="RPM RELEASE: \033[40m\033[001;033m%{release}"
OS="OS TYPE IS : \033[40m\033[001;033m%{ostype}"
GCC="GCC IS     : \033[40m\033[001;033m`cat %{_tmppath}/%{name}-%{pversion}-gcc`"
CCF="CCFLAGS    : \033[40m\033[001;033m%{ccflags}"
LDF="LDFLAGS    : \033[40m\033[001;033m%{ldflags}"

echo
echo
echo -e "\033[40m\033[001;031m\$RPM\033[0m"
echo -e "\033[40m\033[001;031m\$OS\033[0m"
echo -e "\033[40m\033[001;031m\$GCC\033[0m"
echo -e "\033[40m\033[001;031m\$CCF\033[0m"
echo -e "\033[40m\033[001;031m\$LDF\033[0m"
echo
echo

sleep 3

EOF

# Take care to execute and then to delete
chmod u+x %{_tmppath}/%{name}-%{pversion}-show_flags
%{_tmppath}/%{name}-%{pversion}-show_flags
[ -f %{_tmppath}/%{name}-%{pversion}-show_flags ] && rm -f %{_tmppath}/%{name}-%{pversion}-show_flags

%build

[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}

mkdir -p %{buildroot}

# Delete gcc temp file
[ -f %{_tmppath}/%{name}-%{pversion}-gcc ] && rm -f %{_tmppath}/%{name}-%{pversion}-gcc

export CPPFLAGS=""
export CFLAGS="$RPM_OPT_FLAGS -fomit-frame-pointer -fPIC $CPPFLAGS"

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

mkdir -p %{buildroot}%{_sysconfdir}
mkdir -p %{buildroot}%{_bindir}

##
# Commit permanent changes to default configuration
##

install -p -m 644 wwwroot/cgi-bin/awstats.model.conf \
    %{buildroot}/%{_sysconfdir}/%{name}.model.conf

%{__perl} -pi -e '
                s|^LogFile=.*$|LogFile="%{_localstatedir}/log/httpd/access_log"|;
                s|^DirData=.*$|DirData="%{_localstatedir}/lib/awstats"|;
                s|^DirCgi=.*$|DirCgi="/awstats"|;
                s|^DirIcons=.*$|DirIcons="/awstatsicons"|;
                s|^HostAliases=.*$|HostAliases="localhost 127.0.0.1"|;
                s|^EnableLockForUpdate=.*$|EnableLockForUpdate=1|;
                s|^SaveDatabaseFilesWithPermissionsForEveryone=.*$|SaveDatabaseFilesWithPermissionsForEveryone=0|;
                s|^SkipHosts=.*$|SkipHosts="127.0.0.1"|;
                s|^Expires=.*$|Expires=3600|;
        ' %{buildroot}/%{_sysconfdir}/%{name}.model.conf
chmod 644 %{buildroot}/%{_sysconfdir}/%{name}.model.conf 

%{__install} -D -m0755 tools/logresolvemerge.pl           \
	%{buildroot}%{_bindir}/logresolvemerge.pl
%{__install} -D -m0755 tools/awstats_buildstaticpages.pl  \
	%{buildroot}%{_bindir}/awstats_buildstaticpages.pl
%{__install} -D -m0755 tools/awstats_exportlib.pl         \
	%{buildroot}%{_bindir}/awstats_exportlib.pl
%{__install} -D -m0755 tools/awstats_updateall.pl         \
	%{buildroot}%{_bindir}/awstats_updateall.pl
%{__install} -D -m0755 tools/maillogconvert.pl            \
	%{buildroot}%{_bindir}/maillogconvert.pl
%{__install} -D -m0755 tools/urlaliasbuilder.pl           \
	%{buildroot}%{_bindir}/urlaliasbuilder.pl
%{__install} -D -m0755 wwwroot/cgi-bin/awstats.pl         \
	%{buildroot}%{_localstatedir}/www/awstats/awstats.pl
%{__install} -D -m0755 wwwroot/cgi-bin/awredir.pl         \
	%{buildroot}%{_localstatedir}/www/awstats/awredir.pl
%{__install} -D -m0644 wwwroot/classes/awgraphapplet.jar  \
	%{buildroot}%{_localstatedir}/www/awstats/classes/awgraphapplet.jar
%{__install} -D -m0644 wwwroot/js/awstats_misc_tracker.js \
	%{buildroot}%{_localstatedir}/www/awstats/js/awstats_misc_tracker.js

%{__cp} -av wwwroot/{css,icon}/ \
	%{buildroot}%{_localstatedir}/www/awstats/
%{__cp} -av wwwroot/cgi-bin/{lang,lib,plugins} \
	%{buildroot}%{_localstatedir}/www/awstats/

##
# install the main conf
##

cp -f %{SOURCE1} %{buildroot}/%{_sysconfdir}

%clean
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}
[ -d $RPM_BUILD_DIR/%{name}-%{pversion} ] && rm -rf $RPM_BUILD_DIR/%{name}-%{pversion}


%files
%defattr(-,root,root,755)
%doc README.TXT docs/*
%attr(644,root,root) %config(noreplace) %{_sysconfdir}/awstats.conf
%attr(644,root,root) %{_sysconfdir}/awstats.model.conf
%attr(755,root,root) %{_bindir}/*
%{_localstatedir}/www/awstats/

%changelog
* Thu Aug 12 2021 Tim College <tcollege@interworx.com>
- Add support for building for Almalinux 8.x
- Remove EOL OS support
* Tue Jun 07 2016 Paul Oehler <poehler@interworx.com>
- Fixed compatility with new perl regexs
* Tue Aug 10 2010 Jon Daniel <jdaniel@interworx.com>
- Upgraded to AWStats 6.95
* Wed Mar 16 2005 Chris Wells <clwells@nexcess.net>
- Upgraded to AWStats 6.4
* Sat Feb 5 2005 Chris Wells <clwells@nexcess.net>
- Upgraded to AWStats 6.3 and mimic'd DAG's dir structure
* Tue Sep 7 2004 Chris Wells <clwells@nexcess.net>
- Added our awstats.conf to the RPM
* Sun May 30 2004 Chris Wells <clwells@nexcess.net>
- Initial packaging as part of InterWorx-HAL OS


















